type StringAndOthers<T extends unknown[]> = [string, ...T];
type LispyFunction = StringAndOthers<unknown[]>;
type LispyConditionExpr = readonly ['=', string, string | number | boolean | LispyFunction];
type LispyNotExpr = ['not', LispyExpression];
type LispyAndOrExpr = ['and' | 'or', ...LispyExpression[]];
type LispyExpression = LispyNotExpr | LispyAndOrExpr | LispyConditionExpr;
interface FilterEditorOptions {
    container: HTMLElement | string;
    schema: any;
    mainModel: string;
    initialExpression?: LispyExpression;
}

declare class FilterEditor {
    private container;
    private expression;
    private schema;
    private mainModel;
    private fieldsList;
    constructor(options: FilterEditorOptions);
    private init;
    private setupSortableForGroup;
    /**
     * setup a new CascaderSelect
     */
    private setupNewCascaderSelect;
    private setupLookupSelector;
    private setupValueInput;
    private render;
    private renderExpression;
    private renderOperator;
    private renderCondition;
    private renderCommonActions;
    private setupEventListener;
    private actionDelete;
    private actionAddNew;
    private addNewGroup;
    private addNewCondition;
    private actionToggleNot;
    toJson(): LispyExpression;
    private parseGroup;
    private parseCondition;
}

export { FilterEditor };
